/*
 * chkdir_14.c
 */
#ifdef DFC
#undef DFC
#endif

#define DFC ((d1)%BMRADIX==1)



int
skcache_check_dir(int d1, int d2, int d3, int force)
{
    char basename[L_PATH];
    char dirname[L_PATH];
    char tmp[L_PATH];
    char *namechk;
    dirent_t    *elem;
    DIR         *dirp;
#ifdef PC_NAME_MAX
    dirent_t ent[PC_NAME_MAX+1];
#else
#ifdef _PC_NAME_MAX
    dirent_t ent[_PC_NAME_MAX+1];
#else
    dirent_t ent[128];
#endif
#endif
    char name[L_PATH];
    int dfd;
    char buf[L_BUF];
    int n;
    int i;
    int j, k, r;
    int nr;
    int chk;
    off_t sum;
    off_t fsize;
    int lcount, dcount, ecount;
    off_t lsize, dsize, esize;
    int strange = 0;
    int action;
    int life;
    time_t reftime;
    time_t now;
    int nfile;

    int wid, nwid;

    int lastpos;
    off_t dst, bpos;
    off_t tpos;

    tup rec[TUP_MAX];

    struct timeval begin, end;

    bucket_t *bk;
    skcache_entry_t en;
    skcache_entry_t chunk[HARD_NINDEX_BDREAD];
    int c;
    int er=0;

    int igh=0;
    int nw;

    u_int32_t sig[DSIG_ELEM_WIDTH];
    u_int32_t bit[DBIT_ELEM_WIDTH];

    int sig_pos = 0;

    int dmark_count;

    int ac_sum[ACTION_N];
    int taketime;






    gettimeofday(&begin, NULL);
    reftime = begin.tv_sec;
/*
    now = time(NULL);
*/
    now = begin.tv_sec;

    FCHK();


    sig_pos = DSIG_POS(d1, d2, d3);

    dirname[0] = '-';
    dirname[1] = '\0';

#if VD
#endif
 if(DFC) {
Trace("chkdir14: [%4d,%4d,%4d] dir# %d, swaper# %d, time %d force? %d\n",
   d1, d2, d3, sig_pos, d1%MAX(radix_disk, 1), reftime, force);
 }


    lcount  = 0;
    dcount  = 0;
    lsize   = 0;
    dsize   = 0;
    ecount  = 0;
    esize   = 0;

    if(d1<0||d1>=RADIX_H1_MAX
        || d2<0||d2>=RADIX_H2_MAX) {
        Error("chkdir14: ignore directory position %d/%d,%d/%d",
            d1, RADIX_H1_MAX, d2, RADIX_H2_MAX);
        goto out;
    }

#if 0
    if(d1<0||d1>=RADIX_H1_MAX
        || d2<0||d2>=RADIX_H2_MAX
            || d3<0||d3>=RADIX_H3_MAX) {
        Error("chkdir14: ignore directory position %d/%d,%d/%d,%d/%d",
            d1, RADIX_H1_MAX, d2, RADIX_H2_MAX, d3, RADIX_H3_MAX);
        goto out;
    }
#endif

#if 0
    if(d1>=radix_h1 || d2>=radix_h2 || d3>=radix_h3) {
        if(force) {
            Trace("chkdir14: out of current directory range <%d,%d,%d>, try clear\n",
                d1, d2, d3);

            namechk = assign_dirname_bynumber(dirname, d1, d2, -1);
            if(namechk) {
                Trace("chkdir14: clear dir. recursive %s\n", dirname);
                rm_fr(dirname);
            }
        }
        else {
            Trace("chkdir14: out of current directory range <%d,%d,%d>, no change\n",
                d1, d2, d3);
        }

        goto out;
    }
#endif


    dsig_allclear(sig);
    dbit_allclear(bit);

    bk = &skcache_bucket_base[d1];

#ifdef VD2
#endif
 if(DFC) {
    if(dir_sz[sig_pos]>=dir_size_hwater) {
    Trace("  chkdir14: dir# %d, dir_sz %lld %.2fM %.1f%%, sum %lld %.1f%%, lsize %lld %.1f%%\n",
        sig_pos,
        (long long)dir_sz[sig_pos], fdM(dir_sz[sig_pos]),
            (double)100.0*dir_sz[sig_pos]/dir_size_max,
        (long long)sum, (double)100.0*sum/dir_size_max,
        (long long)lsize, (double)100.0*lsize/dir_size_max);
    }
 }


disk_operations:


    n = 0;
    sum = (off_t)0L;


    en.h1 = d1;
    en.h2 = d2;
    en.h3 = 0;
    en.h4 = 0;

    chk = ifd_open(&dfd, bk, &en);
    if(chk) {
        Error("chkdir14: fail ifd_open() for [%d:%d:%d:%d]",
            en.h1, en.h2, en.h3, en.h4);
        goto skip_packedfile;
    }
    if(dfd<0) {
        Error("chkdir14: ignore fd# of index file for [%d:%d:%d:%d]",
            en.h1, en.h2, en.h3, en.h4);
        goto skip_packedfile;
    }

#if 0
    c = 0;
try_lseek2:
    c++;
    fsize = lseek(dfd, 0, SEEK_END);
    if(fsize<(off_t)0) {
        if((errno==EINTR || errno==EINPROGRESS) && c<DISK_RETRY) {
            msleep(3);
            goto try_lseek2;
        }
        Error("chkdir14: fail packed lseek() '%s' %d (%d)",
            name, c, errno);
        goto skip_packedfile;
    }
    if(fsize>(off_t)0) {
        sum += fsize;

        c = 0;
try_lseek2b:
        c++;
        dst = lseek(dfd, 0, SEEK_SET);
        if(dst<0) {
            if((errno==EINTR || errno==EINPROGRESS) && c<DISK_RETRY) {
                msleep(3);
                goto try_lseek2b;
            }
        }
    }
#endif
#if 1
    dst = Iseek(sig_pos, dfd, 0);
#endif


    /* read all entries in packed file */

    if(nindex_bdread>HARD_NINDEX_BDREAD) {
        nindex_bdread = HARD_NINDEX_BDREAD;
    }

    /* read file, store actions in target table 'rec' */

    for(j=0;j<ACTION_N;j++) {
        ac_sum[j] = 0;
    }

    for(j=0;j<OFILE_NBLK_FILE;j += nindex_bdread ) {

        nwid = nindex_bdread;
        wid = nindex_bdread*ESIZE;
        c = 0;
try_read_cntl2:
        c++;
        nr = Iread(sig_pos, dfd, chunk, wid);
        if(nr<0) {
            if(errno==EINTR && c<DISK_RETRY) {
                goto try_read_cntl2;
            }
            Error("chkdir14: file# %d, fail read() '%s' %d (%d)",
                n, name, c, errno);
            goto done_read_cntl2;
        }
#if 0
        if(nr<wid)) {
            action = ACTION_PURGE;
            Error("chkdir14: ignore target# %d, pos %d, read control in packed short than control %d/%d",
                n, j, nr, ESIZE);
            goto fill_rest;
        }
#endif

        if(nr==0) {
            break;
        }

        dst += nr;
        nwid = nr/ESIZE;

        for(k=0; k<nwid && j+k < OFILE_NBLK_FILE ;k++)
        {
            action = ACTION_NOP;
            en = chunk[k];

            decision_disk_action(&en, reftime, &action);

            if(action<ACTION_N) {
                ac_sum[action]++;
            }

#ifdef VD3
 if(DFC) {
            Trace(" p %4d %4d; => %d; oid# %d, %2x %2x i %9d %5d, l %9d %5d, e %9d %5d \n",
                j+k, n, action,
                en.oid, en.magic[0], en.magic[1],
                en.issue_time, reftime - en.issue_time,
                en.lmd, reftime - en.lmd,
                en.expire, reftime - en.expire
            );

 }
#endif

            if(n>=TUP_MAX) {
                er++;
                if(er==1) {
                    Error(
                        "dir '%s', tup overflow read %d th, store %d th in %d",
                        dirname, i, n, TUP_MAX);
                }
                break;
            }

            rec[n].no = en.h4; 

/*
Trace("n %d %d <- %s\n", n, rec[n].no, elem->d_name);
*/
            rec[n].type = 1;    /* packed */
            rec[n].pos  = j+k;
            rec[n].act  = action;
            rec[n].date = en.issue_time;
            rec[n].sz   = OFILE_BLKSIZE; /* XXX */
            n++;
        }

    }

#if 1
    if(n!=OFILE_NBLK_FILE) {
        Trace(" 0 [%d:%d] n %d, OFILE_NBLK_FILE %d\n", d1, d2, n, OFILE_NBLK_FILE);
    }
#endif

#ifdef CHECK_OPOS
    {
        skcache_entry_t dummy;
        int tnr;
        off_t act_fsize, cpos;

        cpos = lseek(dfd, 0, SEEK_CUR);
        if(cpos<(off_t)0L) {
            Error("chkdir14: fail lseek() for current position checking (%d)",
                errno);
        }
        act_fsize = lseek(dfd, 0, SEEK_END);
        if(act_fsize<(off_t)0L) {
            Error("chkdir14: fail lseek() for end position checking (%d)",
                errno);
            goto done_read_cntl2;
        }

        dst = act_fsize;

        if(act_fsize != (off_t)(OFILE_NBLK_FILE*ESIZE) ) {
            Error("chkdir14:* unexpected file size %lld (expect %lld) (cur %lld) [%d:%d]",
                (long long) act_fsize,
                (long long)OFILE_NBLK_FILE*ESIZE,
                (long long) cpos,
                d1, d2);

        }

fail_opos_check:
        (void)1;
    }
#endif

    goto done_read_cntl2;

fill_rest:
    Trace("  dir# %d, fill rest [%d..%d) of packed file\n",
        sig_pos, j, OFILE_NBLK_FILE);

    for(;j<OFILE_NBLK_FILE;j++) {
        rec[n].no = -1;
/*
Trace("n %d %d <- %s\n", n, rec[n].no, elem->d_name);
*/
        rec[n].type = 1;    /* packed */
        rec[n].pos  = j;
        rec[n].act  = 2;
        rec[n].date = 0;
        rec[n].sz   = OFILE_BLKSIZE; /* XXX */
        n++;

    }


#if 1
    Trace(" 1 [%d:%d] n %d, OFILE_NBLK_FILE %d\n", d1, d2, n, OFILE_NBLK_FILE);
#endif




done_read_cntl2:
    (void)1;

    
skip_packedfile:
    (void)1;


    nfile = 1;

#ifdef VD
    Trace("  dir# %d, nfile %d, record %d %d %d, \n",
        sig_pos, nfile, n, OFILE_NBLK_FILE, TUP_MAX);
#endif
 if(DFC) {
    int s;
    s = ac_sum[0] + ac_sum[1] + ac_sum[2] + ac_sum[3] + ac_sum[4] + ac_sum[5];
    Trace("  dir# %d, n %d; act known %d, unknown %d ; nop/keep %d, skip/swapout %d, purge %d, swapout+purge %d, mark %d, unlink %d\n",
        sig_pos, n, s, OFILE_NBLK_FILE-s,
        ac_sum[0], ac_sum[1], ac_sum[2], ac_sum[3], ac_sum[4], ac_sum[5]);
 }

#if 0
    if(nfile<=0 && has_index==0) {
        goto report_phase;
    }
#endif

#ifdef VD3
    show_tup("after  dir.sweeping", n, rec);
#endif

#ifdef VD3
    Trace("  sweeped file size, sum %lld\n", (long long) sum);
#endif


    /***
     *** main body of compaction
     ***/

#ifdef VD3
 if(DFC) {
    show_tup("before sort1", n, rec);
 }
#endif


    /* 
     * sort by action, date and size
     *     ? black and gray objects will locate to top.
     *      white and gray objects will locate to top.
     *      black and part of gray will be purged.
     *
     */
    qsort(rec, n, sizeof(tup), comp_tup);
#ifdef VD2
 if(DFC) {
    show_tup("after  sort1", n, rec);
 }
#endif

#ifdef VD2
    Trace("  lwater %lld\n", (long long)dir_size_lwater);
#endif

    for(i=0;i<n;i++) {
        int xh1, xh2, xh3, xh4;

        xh4 = rec[i].no;
#if 0
        Trace("%4d: no# %7d act %2d date %d size %12lld\n",
            i, rec[i].no, rec[i].act, rec[i].date, (long long)rec[i].sz);
#endif

        if(lsize + rec[i].sz > dir_size_lwater) {
#ifdef VD2
            Trace("  change to PURGE from idx %4d pos %4d\n", i, rec[i].pos);
#endif
            break;
        }

        switch(rec[i].act) {
        case ACTION_NOP:
#if 1
        case ACTION_SKIP:
#endif
            /* mark with xh4 */
            DSIG_TMP_SET(sig, xh4);
            DBIT_TMP_SET(bit, rec[i].pos);
            lcount++;
            lsize += rec[i].sz;
            break;

#if 0
        case ACTION_SKIP:
            ecount++;
            esize += rec[i].sz;
            break;
#endif

        case ACTION_PURGE:
        case ACTION_UNLINK:
            dcount++;
            dsize += rec[i].sz;
            break;

        default:
            break;

        }
    }
    for(;i<n;i++) {
        rec[i].act = ACTION_PURGE;
        dcount++;
        dsize += rec[i].sz;
    }

#ifdef VD
        Trace(
"\tthen, l %9lld d %9lld e %9lld : free %12lld %.2f%%\n",
            (long long)lsize, (long long)dsize, (long long)esize,
            (long long) (dir_size_max - lsize),
            (double)(dir_size_max - lsize)*100.0/dir_size_max
             );
#endif

    /*
     * to optimize disk access, sort them with location order
     *
     */
    qsort(rec, n, sizeof(tup), comp_tup_order);

#ifdef VD3
    show_tup("after  sort2", n, rec);
#endif

    c = 0;
try_lseek_before_writeback:
    c++;
#if 0
    dst = lseek(dfd, (off_t)0L, SEEK_SET);
#endif
    dst = Iseek(sig_pos, dfd, (off_t)0L);
    if(dst<(off_t)0L) {
        if(errno==EINTR && c<DISK_RETRY) {
            goto try_lseek_before_writeback;
        }
        Error("chkdir14: before write-back, fail lseek() fd# %d, (%d)\n",
            dfd, errno);
    }

    for(i=0;i<n;i++) {
        int xh1, xh2, xh3, xh4;

        if(rec[i].type==1) {
            break;
        }
        if(rec[i].type==0) {
        }

#if 0
        xh4 = rec[i].no;
        sprintf(name, "%s/%d", dirname, xh4);
#endif

#ifdef VD4
Trace("i %d no %d xh4 %d -> %s\n", i, rec[i].no, xh4, name);
#endif

        switch(rec[i].act) {
        case ACTION_PURGE:
            break;

        case ACTION_UNLINK:
            break;
        }
    }

    en.magic[0] = MAGIC_0 & 0xaa;
    en.magic[1] = MAGIC_1 & 0x55;
    en.h1   = -7;
    en.h2   = -17;
    en.h3   = -13;
    en.h4   = -57;
    en.oid  = 0;
    en.issue_time = -1;


#ifdef TRACE_POS2
#endif
#if 0
    for(;i<n;i++) {
        Trace("  del? %4d: pos %4d th slot, action %d\n", i, rec[i].pos, rec[i].act);
    }
#endif
#if 0
    if(DFC) {
        Trace("  del? %4d: pos %4d th slot, action %d\n",
            i, rec[i].pos, rec[i].act);
    }
#endif

    dmark_count = 0;
    r = 0;
    
    lastpos = -1;
    tpos = (off_t)0;
    for(;i<n;i++) {
        int xh1, xh2, xh3, xh4;
        int wid, rest, cwid;
        int k;
        struct iovec iov[HARD_NINDEX_BDWRITE];

        r++;

        xh4 = rec[i].no;

        if(rec[i].act==ACTION_PURGE||rec[i].act==ACTION_UNLINK) {
            bpos = rec[i].pos*ESIZE;

            dst = Iseek(sig_pos, dfd, bpos);
            if(dst<(off_t)0) {
                Error(
"chkdir14: cannot seek tpos +%lldB, pos %d %lldB on index file fd# %d :%d (%d)",
            (long long)tpos,
            (long)rec[i].pos, (long long)rec[i].pos* ESIZE,
            dfd, c, errno);
                    goto report_phase;
            }

#if 1
            j = i;
            while(j<n && rec[j].act == rec[i].act) {
                j++;
            }
/*
            Trace("  focus(i) %d act %d and last of chunk(j) %d act %d\n",
                i, rec[i].act, j, rec[j].act);
*/
#if 0
 if(DFC) {
            Trace("  dir# %d, del [%d..%d]\n", sig_pos, i, j-1);
 }
#endif

            {
                nindex_bdwrite = 32;

                wid = rest = j-i-1;

                while(rest>0) {
                    cwid = MIN(rest, nindex_bdwrite);
#if 0
Trace("     wid %4d, rest %4d, cwid %4d\n", wid, rest, cwid);
#endif

                    for(k=0;k<cwid;k++) {
                        iov[k].iov_base = &en;
                        iov[k].iov_len = ESIZE;
                    }

                    nw = Iwritev(sig_pos, dfd, iov, cwid);
                    if(nw<0) {
                        Error(
    "chkdir14: fail deletation marking dfd# %d, (%d)",
                            dfd, errno);
                        goto skip_deleting;
                    }
                    rest-= cwid;
                    dst += nw;
                    dmark_count += cwid;
                }
              
                if(r>n) {
                    Trace("  escape %d/%d, bk# %d,\n", r, n, sig_pos);
                    break;
                }

                if(i+wid+1 >= n) {
#if 0
                    Trace("  reach to end\n");
#endif
                    break;
                }
                else {
/*
                    i += wid - 1;
*/
                    i += wid;
                }
            }
#endif

#if 0
            nw = Iwrite(sig_pos, dfd, &en, ESIZE);
            if(nw<0) {
                Error("chkdir14: fail deletation marking dfd# %d, (%d)",
                    dfd, errno);
                goto skip_deleting;
            }

#if 0
            if(nw!=ESIZE) {
                Error("chkdir14: fail write deletation marking dfd# %d, nw %d",
                    dfd, nw);
                goto skip_deleting;
            }
#endif

            dst += nw;
            dmark_count++;
            lastpos = rec[i].pos;
#endif
        }
        else {
        }

    }

skip_deleting:
    (void)0;

#ifdef VD
    Trace("  write deletation mark %d\n", dmark_count);
#endif

#if 1
    if(dst>(off_t) OFILE_NBLK_FILE*ESIZE) { 
        Error("INDEX [%03d:%03d] overrun %lldB (%ld slots) ; expect %lldB (%ldB entry x %ld slots)",
            d1, d2,
            (long long) dst, (long)((long long)dst/ESIZE),
            (long long) OFILE_NBLK_FILE*ESIZE,
            (long) ESIZE, (long) OFILE_NBLK_FILE);
    }
#endif
#if 0
    dst = lseek(dfd, 0, SEEK_END);
    if(dst!= (off_t) OFILE_NBLK_FILE*ESIZE) {
        Error("INDEX [%03d:%03d] ignore size %lldB (%ld slots) ; expect %lldB (%ldB entry x %ld slots)",
            d1, d2,
            (long long) dst, (long)((long long)dst/ESIZE),
            (long long) OFILE_NBLK_FILE*ESIZE,
            (long) ESIZE, (long) OFILE_NBLK_FILE);

    }
#endif

report_phase:

    now = time(NULL);

#ifdef VD
#endif
 if(DFC) {
    Trace(" dd dir# %d, %-24s %4d sum %8ld + %d\
/ live %4d %8ld / dead %4d %8ld\
/ untouch %4d %8ld / %2d\n",
        sig_pos, dirname, n, (long)sum, strange,
        lcount, (long)lsize, dcount, (long)dsize, ecount, (long)esize,
        now - reftime
        );
  }

    MUTEX_LOCK(&stat_lock);

    checkdir_dir_count++;
    checkdir_file_read_count    += nfile;
    checkdir_file_handle_count  += n;
    checkdir_file_left_count    += lcount;
    checkdir_file_delete_count  += dcount;
    checkdir_file_erase_count   += ecount;

    check_dir_ignore_hash_count = igh;

    if(dcount>0 && dsize>0) {
        swap_count  -= dcount;
        swap_size   -= dsize;
    }

    MUTEX_UNLOCK(&stat_lock);

    if(force) {
#if 0 
        MUTEX_LOCK(&dir_mutex);
#endif

        memcpy((void*)&dir_sig[sig_pos*DSIG_ELEM_WIDTH],
            (void*)&sig, DSIG_ELEM_WIDTH*sizeof(u_int32_t));
        memcpy((void*)&dir_bit[sig_pos*DBIT_ELEM_WIDTH],
            (void*)&bit, DBIT_ELEM_WIDTH*sizeof(u_int32_t));

        dir_sz[sig_pos]     = lsize;
        dir_count[sig_pos]  = lcount;
        dir_time[sig_pos]   = now;
        dir_lack[sig_pos]   = 0;

#if 0
        MUTEX_UNLOCK(&dir_mutex);
#endif
    }


out:

    gettimeofday(&end, NULL);
    taketime = KOTETU_SUB_TIME(end, begin);
    sim_stat_add_value(&checkdir_time, taketime);
    sim_stat_add_value(&checkdir_time_short, taketime);

#ifdef TRACE_CHKDIR
#endif
 if(DFC) {
    Trace("  done chkdir14 dir# %d, takes %d msec, %-17s left %4df %8ldB %7.2fKB  th %08x\n",
        sig_pos, taketime, dirname,
        lcount, (long)lsize, fdK(lsize), pthread_self());
 }
#if 0
    Trace("chkdir14: dir# %d, takes %d sec, %-17s left %4df %8ldB %7.2fKB  th %08x\n",
        sig_pos, taketime, dirname,
        lcount, (long)lsize, fdK(lsize), pthread_self());
#endif

end:
    FCHK();

    return 0;
}


/*** end of chkdir_14.c ***/
