/*
 * trace.h: header for trace routines
 *      by k-chinen@is.aist-nara.ac.jp, 2001.
 *
 * $Id$
 */

extern char *global_trace_mask;

typedef struct {
    int reg;
    char *name;
    char *nic;
    int sw;
} mon_t;

int mon_receipt(mon_t*);
int wake_traces(void);

#define MID  mon_ 

#define TRACE_REGIST            static mon_t MID = { 0, __FILE__, NULL, 0}
#define TRACE_REGIST_NAME(x)    static mon_t MID = { 0, x, NULL, 0}
#define TRACE_REGIST_NIC(y)     static mon_t MID = { 0, __FILE__, y, 0}

#define TRACE_RECEIPT           if(MID.reg==0) mon_receipt(&MID)

#define TRACEON     if(MID.sw != 1) MID.sw = 1
#define TRACEOFF    if(MID.sw != 0) MID.sw = 0

#define XPASS    if(MID.reg==0) mon_receipt(&MID); \
    if(MID.sw) {fprintf(stderr, "pass %s %d\n", __FILE__, __LINE__);}
#define PASS    if(MID.sw){fprintf(stderr,"pass %08x %s %d\n", \
    pthread_self(),__FILE__,__LINE__);}

#ifdef Trace
#undef Trace
#endif
#define Trace   if(MID.sw) RawTrace
/*
#define Trace if(MID.reg==0) mon_receipt(&MID); \
    if(MID.sw) RawTrace
*/

